/*************************************************************************/
/*************************************************************************/
/* H. Timucin OZDEMIR                                                    */
/* Date : March, 1997                                                    */
/* File Name : bellMF.cc                                                 */
/*************************************************************************/
/*************************************************************************/

#include <iostream.h>
#include "bellMF.h"
#include "XbellMF.h"
#include "../deffunc.h"
#include <math.h>

bellMF::bellMF(float _center, float _std, float _slop)
{  center = _center;
   stdeviation = _std;
   slope = _slop;
   cutOff = 1.0;
}// end of constructor

void bellMF::setCenter(float _newValue) {  center = _newValue; }

void bellMF::setSlope(float _newValue) {  slope = _newValue; }

void bellMF::setSpread(float _newValue) { stdeviation = _newValue; }

float bellMF::getSpread() const {  return stdeviation; }

float bellMF::getCenter() const {  return center; }

float bellMF::getSlope() const {  return slope; }

float bellMF::getValue(float x) 
{  float ret;
   ret = 1 + pow(fabs((x-center)/stdeviation),2.0*slope);
   return minimum(1.0/ret,cutOff); 
}// end of getValue()

Function * bellMF::Xversion()
{  XbellMF *ret = new XbellMF(center,stdeviation, slope);
   (*ret).setCutOff(cutOff);
   return ret;
}// end of Xversion()

Function * bellMF::getMyTwin()
{  bellMF *ret = new bellMF(center,stdeviation, slope);
   (*ret).setCutOff(cutOff);
   return ret;
}// end of getMyTwin()

ostream& operator<<(ostream& os, const bellMF& RHS)
{
   os << " Bell(" << RHS.getCenter() << "," << RHS.getSlope() << ",";
   os << RHS.getSpread() << ") with " << RHS.getCutOff() << endl;
   return os;
}// end of operator<<

void bellMF::printOn(ostream& os) const {  os<<(*this); }


